//****************
module  ELF_LOGIC_BUF(o,i);     // user instantiated logic BUF
output o;
input i;
endmodule
//****************
//****************
module  ELF_LOGIC_BUFG(o,i);  // driver for global clk resource
output o;
input i;
endmodule
//****************
//****************
module ELF_LOGIC_CCLK(cclk);  // config clk
output cclk;
endmodule
//****************
//****************
module  ELF_LOGIC_IDELAY(o,i);
output o;
input i;
parameter INDEL = 0;  // 0-31
endmodule
//****************
//****************
module ELF_LOGIC_IDDR (q1, q2, clk, d, rst);
    output q1;
    output q2;
    input clk;
    input d;
    input rst;
    parameter SRMODE = "SYNC"; //SYNC, ASYNC
endmodule
//****************
//****************
module ELF_LOGIC_ODDR (q, clk, d1, d2, rst);
    output q;
    input clk;
    input d1;
    input d2;
    input rst;
    parameter SRMODE = "SYNC"; //SYNC, ASYNC
endmodule
//****************
//****************
module ELF_LOGIC_DRAM (di, waddr, we, wclk, do, raddr);
parameter DATA_WIDTH_W = 9;
parameter ADDR_WIDTH_W = 10;
parameter DATA_DEPTH_W = 2 ** ADDR_WIDTH_W;
parameter DATA_WIDTH_R = 9;
parameter ADDR_WIDTH_R = 10;
parameter DATA_DEPTH_R = 2 ** ADDR_WIDTH_R;
input [DATA_WIDTH_W-1:0]di;
input [ADDR_WIDTH_W-1:0]waddr;
input wclk;
input we;
output [DATA_WIDTH_R-1:0]do;
input [ADDR_WIDTH_R-1:0]raddr;
parameter INIT_FILE = "NONE";
endmodule
//****************
//****************
module ELF_LOGIC_SEQ_DIV (clk, rst, start, numer, denom, quotient, remain, done);

  parameter NUMER_WIDTH = 16;
  parameter DENOM_WIDTH = 16;
  input                     clk;
  input                     rst;  
  input                     start;  
  input  [NUMER_WIDTH-1:0]  numer;  
  input  [DENOM_WIDTH-1:0]  denom;  
  output [NUMER_WIDTH-1:0]  quotient;  
  output [DENOM_WIDTH-1:0]  remain;  
  output                    done;
endmodule
//****************
//****************
module ELF_LOGIC_DRAM32X4 ( di, waddr, we, wclk, raddr, do);
parameter INIT_D0=16'h0000;
parameter INIT_D1=16'h0000;
parameter INIT_D2=16'h0000;
parameter INIT_D3=16'h0000;
parameter INIT_D4=16'h0000;
parameter INIT_D5=16'h0000;
parameter INIT_D6=16'h0000;
parameter INIT_D7=16'h0000;
  input [3:0]di;
  input [4:0]waddr;
  input wclk;
  input we;
  input [4:0]raddr;
  output [3:0]do;
endmodule
//****************
//****************
module ELF_PHY_DRAMHARDCON ( b, sload, clk0, mi7,dpram_di,dpram_we,dpram_waddr,dpram_wclk,dpram_mode); 
    parameter MODE = "DPRAM" ;
    input [7:0] b;
    input sload;
    input clk0;
    input mi7;
    output [3:0] dpram_di;
    output dpram_we;
    output [4:0] dpram_waddr;
    output dpram_wclk;
    output dpram_mode;
endmodule
//****************
//****************
module ELF_LOGIC_DRAM32X4W4R8 ( di, waddr, we, wclk, raddr, do);
parameter INIT_D0=16'h0000;
parameter INIT_D1=16'h0000;
parameter INIT_D2=16'h0000;
parameter INIT_D3=16'h0000;
parameter INIT_D4=16'h0000;
parameter INIT_D5=16'h0000;
parameter INIT_D6=16'h0000;
parameter INIT_D7=16'h0000;
  input [3:0]di;
  input [4:0]waddr;
  input wclk;
  input we;
  input [3:0]raddr;
  output [7:0]do;
endmodule
//****************
//****************
module ELF_PHY_OSC (osc_dis, osc_clk);
    input osc_dis;
    output osc_clk;
    parameter FREQ = "60"; // 60, 30 MHz
endmodule
//****************
//****************
module ELF_PHY_MSLICE
  (
  a,
  b,
  c,
  d,
  ce,
  clk,
  mi,
  ssr,
  asr,
  fci,
  fco,  
  sload,  
  f,
  q,
  shift_in,
  shift_out, 
  dpram_mode,
  dpram_di,
  dpram_we,
  dpram_waddr,
  dpram_wclk,
  glb
  );
  input [1:0] a,b,c,d,mi;
  input clk;
  input ce;
  input ssr;
  input asr;  
  input sload;
  input fci;
  input shift_in;
  output shift_out;
  output [1:0] f,q;
  output fco;    
  input dpram_mode;
  input dpram_di;
  input dpram_we;
  input dpram_wclk;
  input [4:0]dpram_waddr;
  input glb;
parameter INIT_LUT0 = 16'h0000 ;
parameter INIT_LUT1 = 16'h0000 ;
parameter MODE = "LOGIC" ; // LOGIC/RIPPLE/DPRAM
parameter FMUX0 = "LUT4"; //LUT4,FUNC5
parameter FMUX1 = "LUT4"; //LUT4,FUNC6,FUNC7
parameter GSR = "ENABLE" ;
parameter CEMUX = "CE" ;
parameter ALUTYPE = "";
parameter ASRMUX = "ASR" ;
parameter CLKMUX = "CLK" ;
parameter DFFMODE = "FF" ;
parameter SHIFT = "DISABLE"; // DISABLE/ENABLE
parameter REG0_SD = "F" ; // F/MI/DYN
parameter REG1_SD = "F" ; // 
parameter REG0_REGSET = "RESET" ; // RESET/SET
parameter REG1_REGSET = "RESET" ;
parameter SSRMUX = "0";
parameter SSRSTATUS = "DISABLE"; // DISABLE/ENABLE
parameter SSRMODE = "OFF"; // OFF/CE_OVER_SSR
parameter SELGLB = "DISABLE"; // DISABLE/ENABLE , this parameter is not be USED now.
endmodule
//****************
//****************
module ELF_PHY_PAD (ipad, opad, bpad, rst, ce, clk, eninr_dyn, ts, otrue, ocomp, itrue, icomp);
    parameter DEDCLK     = "DISABLE";   //DISABLE, ENABLE
    parameter GSR        = "ENABLE";    //ENABLE, DISABLE
    parameter SRMODE     = "SYNC";      //SYNC, ASYNC
    parameter TSMUX      = "1";         //1, 0, TS, INV
    parameter INCLKMUX   = "0";         //0, 1, CLK, INV
    parameter INCEMUX    = "CE";        //CE, INV, 1
    parameter INRSTMUX   = "0";         //0, RST, INV
    parameter IDDRMODE   = "OFF";       //OFF, ON
    parameter INDELMUX   = "NODEL";     //NODEL, FIXDEL
    parameter INDEL      = 0;           // 0-31
    parameter OUTCLKMUX  = "0";         //0, 1, CLK, INV
    parameter OUTCEMUX   = "CE";        //CE, INV, 1
    parameter OUTRSTMUX  = "0";         //0, RST, INV
    parameter ODDRMODE   = "OFF";       //OFF, ON
    parameter IN_DFFMODE = "NONE";      //NONE, FF, LATCH
    parameter IN_REGSET  = "RESET";     //RESET, SET
    parameter DO_DFFMODE = "NONE";      //NONE, FF, LATCH
    parameter DO_REGSET  = "RESET";     //RESET, SET
    parameter TO_DFFMODE = "NONE";      //NONE, FF, LATCH
    parameter TO_REGSET  = "RESET";     //RESET, SET
    parameter MODE       = "IN";        //IN, OUT, BI
    parameter DRIVE      = "NONE";      //NONE, 8, 12, 16, 20 24
    parameter IOTYPE     = "LVCMOS25";  //LVCMOS25, LVCMOS12, LVCMOS18, LVCMOS33, LVDS25 ...
    input  ipad;
    output opad;
    inout  bpad;
    input  rst, ce, clk;
    input  eninr_dyn, ts;
    input  otrue;
    input  ocomp;
    output itrue;
    output icomp;
endmodule
//****************
//****************
module ELF_PHY_CONFIG(
  wb_dat_o,wb_wt_en,wb_cyc_en,wb_stb_en,wb_rst, wb_dat_i,
  wb_adr_i, wb_clk_i,ufm_tbit_o, pib_ufm_cs,pib_ufm_ae,
  pib_ufm_oe,pib_ufm_prog,pib_ufm_nvstr,pib_ufm_sera,
  pib_done,pib_freeze_io,cclk,pib_programn,pib_ts_all,
  pib_user_clk,pib_user_gsr,gsrn_sync_clk,jce,jrstn,
  jrti,jshift,jtck,jtdi,jtms,jupdate,jtdo);

  output [7:0] wb_dat_o;
  input wb_wt_en;  
  input wb_cyc_en; 
  input wb_stb_en; 
  input wb_rst;    
  input [7:0] wb_dat_i;
  input [3:0] wb_adr_i;
  input wb_clk_i;  
  output ufm_tbit_o; 
  input pib_ufm_cs;
  input pib_ufm_ae;
  input pib_ufm_oe;
  input pib_ufm_prog;
  input pib_ufm_nvstr;
  input pib_ufm_sera;
  output pib_done;
  output pib_freeze_io;
  output cclk;
  input pib_programn;
  input pib_ts_all;
  input pib_user_clk;
  input pib_user_gsr;
  input gsrn_sync_clk;
  output [1:0] jce;
  output jrstn;
  output [1:0] jrti;
  output jshift;
  output jtck;
  output jtdi;
  output jtms;
  output jupdate;
  input [1:0] jtdo;
  parameter DISOSC = "DISABLE";       //DISABLE, ENABLE
  parameter CFGSTDBY = "DISABLE";     //DISABLE, ENABLE
  parameter I2CWAKEUP = "DISABLE";    //DISABLE, ENABLE
  parameter TSALL = "DISABLE";        //DISABLE, ENABLE
  parameter TSINV = "DISABLE";        //DISABLE, ENABLE
  parameter ISP1 = "DISABLE";         //DISABLE, ENABLE
  parameter ISP2 = "DISABLE";         //DISABLE, ENABLE
  parameter DONE_PHASE = "0";         //0,1,2,3
  parameter GOE_PHASE = "0";          //0,1,2,3
  parameter GSR_PHASE = "0";          //0,1,2,3
  parameter GWE_PHASE = "0";          //0,1,2,3
  parameter SYNSRC = "DISABLE";       //DISABLE, ENABLE
  parameter SYNEXTDONE = "DISABLE";   //DISABLE, ENABLE
  parameter FORCEGSRN = "DISABLE";    //DISABLE, ENABLE
  parameter FORCEGWE = "DISABLE";     //DISABLE, ENABLE
  parameter USR_GSRN = "DISABLE";     //DISABLE, ENABLE
  parameter GSRMODE = "ASYNC";        //ASYNC, SYNC
  parameter I2C_PERSISTN = "DISABLE"; //DISABLE, ENABLE
  parameter MSPI_PERSIST = "DISABLE"; //DISABLE, ENABLE
  parameter PLLCHECK = "DISABLE";     //DISABLE, ENABLE
  parameter PIBMCLK = "DISABLE";      //DISABLE, ENABLE
  parameter PIBMCLKDIV = 1;         //1-64 (same as pll div for bitgen)
  parameter PWRDWN = "DISABLE";       //DISABLE, ENABL
  parameter mc1_i2c_mspi = "0";       // 0, 1
  parameter mc1_i2c_persistn = "0";       // 0, 1
endmodule
//****************
//****************
module ELF_PHY_GCLK (clki, clko);
    input clki;
    output clko;
endmodule
//****************
