module cfg_int(
//cfg interface
  jtdi,
  jtck,
  jrstn,
  jscan,
  jshift,
  jupdate,
  jtdo,
//trig interface
  status,
  control
);

parameter CTRL_REG_LEN = 22;
parameter STAT_REG_LEN = 18;

//cfg interface
output [1:0]  jtdo;

input         jtdi;
input         jtck;
input         jrstn;
input         jshift;
input         jupdate;
input [1:0]   jscan;

wire  [1:0]   jtdo;
wire          rst;
wire          scan_1;
wire          shift_0;
wire          shift_1;
wire          update_0;

//trig interface
output [CTRL_REG_LEN-1:0] control;
input  [STAT_REG_LEN-1:0] status;

register #( 
      .CTRL_REG_LEN(CTRL_REG_LEN),
      .STAT_REG_LEN(STAT_REG_LEN)
    ) reg_inst(	
      .jtdi(jtdi),
      .jtck(jtck), 
      .rst(rst),
      .scan_1(scan_1),
      .shift_0(shift_0),
      .shift_1(shift_1),
      .update_0(update_0),
      .status(status),
      .jtdo(jtdo),
      .ctrl_r(control)
   );

tap tap_inst(
      .jrstn(jrstn),
      .jscan(jscan),
      .jshift(jshift),
      .jupdate(jupdate),
      .jtdi(jtdi),
      .jtck(jtck),
      .rst(rst),
      .scan_1(scan_1),
      .shift_0(shift_0),
      .shift_1(shift_1),
      .update_0(update_0)
  );


endmodule

