//-----------------------------------------//
// $Module Name: tap.v
// $Author: hsun
// $Date: 2018/11/15
//-----------------------------------------//

module tap(
  jrstn,
  jscan,
  jshift,
  jupdate,
  jtdi,
  jtck,  
  rst,
  scan_1,
  shift_0,
  shift_1,
  update_0
);
//outputs
  output      rst;
  output      scan_1;
  output      shift_0;
  output      shift_1;
  output      update_0;
//inputs
  input       jrstn;
  input [1:0] jscan;
  input       jshift;
  input       jupdate;
  input       jtdi;
  input       jtck;

  wire        scan_1;
  wire        shift_0;
  wire        shift_1;
  wire        update_0;
  
  reg         rst;
  reg         jscan_1_r;
  reg         jscan_1_r2;
  reg         jupdate_r;

  assign shift_0 = jshift & jscan[0];

  always @(posedge jtck or posedge rst)
  begin
       if(rst)
       begin
            jscan_1_r <= 1'b0;
	    jscan_1_r2 <= 1'b0;
       end
       else begin
	    jscan_1_r <= jscan[1];
	    jscan_1_r2 <= jscan_1_r;
       end
  end

  assign shift_1 = jshift & ~scan_1 & jscan[1];
  assign scan_1 = jscan_1_r & ~jscan_1_r2;
  assign update_0 = jupdate;

  always @(negedge jtck or posedge jrstn)
  begin
       if(jrstn) begin
	  rst <= 1'b1;
       end
       else begin
	  rst <= 1'b0;
       end
  end

endmodule
