///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2011-2021 Anlogic, Inc.
// All Right Reserved.
///////////////////////////////////////////////////////////////////////////////
//
//
//   Vendor : Anlogic
//   Version : 0.1
//   Description : Anlogic Functional Simulation Library Component
//            basic gates for user instantiation 
//   Filename : al_logic_gate.v
//   Timestamp : Mon Nov  4 14:20:41 CST 2013
//
///////////////////////////////////////////////////////////////////////////////
//
// Revision:
//    11/04/13 - Initial version.
//
///////////////////////////////////////////////////////////////////////////////

`timescale  1 ns / 1 ps

module  AL_LOGIC_BUF(o,i);     // user instantiated logic BUF
output o;
input i;

	buf lbuf (o, i);

endmodule

module  AL_LOGIC_GSRN(gsrn);   // user controllable GSRN
input gsrn;

parameter USR_GSRN_EN   = "ENABLE";  // DISABLE/ENABLE set by wakeup register

always @(*)
begin
  #0.1 glbl.usr_gsrn_en <= (USR_GSRN_EN == "ENABLE") ? 1'b1 : 1'b0;
  #0.1 glbl.gsrn <= (USR_GSRN_EN == "ENABLE") ? gsrn : 1'b1;
  #0.1 glbl.gsr <= ~glbl.gsrn;
end

endmodule

