module AL_PHY_CONFIG(jrstn,jrti, jshift, jtck,jtdi, 
	jupdate,jscanen, jtms,jtdo,jtag8_ipa,jtag8_ipb,
	done,highz,cclk,usr_gsrn,gsrn_sync_clk,mboot_rebootn,mboot_dynamic_addr);

  output       jrstn;
  output [0:1] jrti;
  output       jshift;
  output       jtck;
  output       jtdi;
  output       jupdate;
  output [0:1] jscanen;
  output       jtms;
  input [0:1]  jtdo;
  input [0:7]  jtag8_ipa;
  input [0:7]  jtag8_ipb;
  output       done;
  output       highz;
  output       cclk;
  input        usr_gsrn;
  input        gsrn_sync_clk;

  //Multi boot
  input          mboot_rebootn;
  input [7:0]    mboot_dynamic_addr;

//  //DNA IP
//  output         dna_dout;
//  input          dna_clk;
//  input          dna_din;
//  input          dna_shift_en;

  //Parameter 
  //multiboot
  parameter MBOOT_AUTO_SEL = "DISABLE";   // DISABLE/ENABLE
  parameter ADDR_SOURCE_SEL = "STATIC";   // STATIC/DYNAMIC. STATIC:0, DYNAMIC:1
  parameter STATIC_ADDR = 8'b0;           // 0/1

  //other
  parameter GSRN_SYNC_SEL = "DISABLE";	// DISABLE/ENABLE set by wakeup register
  parameter USR_GSRN_EN = "DISABLE";	// DISABLE/ENABLE set by wakeup register

  // GSR implementation
  reg [1:0] usr_gsrn_sync;

  initial
  begin
    usr_gsrn_sync = 2'b00;
  end

  always @(posedge gsrn_sync_clk)
    usr_gsrn_sync <= {usr_gsrn_sync[1], usr_gsrn};

  always @(*)
  begin
    #0.1 glbl.usr_gsrn_en <= (USR_GSRN_EN == "ENABLE") ? 1'b1 : 1'b0;
    #0.1 glbl.gsrn <= (USR_GSRN_EN == "ENABLE") ? ((GSRN_SYNC_SEL == "ENABLE") ? usr_gsrn_sync[1] : usr_gsrn) : 1'b1;
    #0.1 glbl.gsr <= ~glbl.gsrn;
  end

endmodule
