module EF2_PHY_MIPIIO(pad_p, pad_n, lp_rx_en, lp_dir, lp_dout, lp_din, dynres, hs_dir, diq, vcmpd_n, do, ipclk, isclk, opclk, osclk, rst);
inout        pad_p;      //to pad
inout        pad_n;        //to pad
input  [1:0] lp_rx_en;   //mipi_lp_rx           mipi lp rx enable, high active            
input  [1:0] lp_dir;     //mipi_lp_to           mipi lp output direction, low output
input  [1:0] lp_dout;    //mipi_lp_do           mipi lp dout   
output [1:0] lp_din;     //mipi_lp_di           mipi lp din
input  [1:0] dynres;     //sg12_eninr_dyn       dymanic terminal resister for hs rx
input        hs_dir;     //ts                   mipi hs output direction, low ouput       
output [3:0] diq;        //diq                  mipi hs Input data        
input        vcmpd_n;    //vcmpd_n              pull up/down resister for hs tx vcm   
input  [3:0] do;       //doq                  mipi hs output data
input        ipclk;
input        isclk;
input        opclk;
input        osclk;
input        rst;

    parameter MODE       = "IN";        //IN, OUT, BI
//  parameter ASYNCRST   = "ENABLE" ;   //ENABLE, DISABLE
//  parameter HS_MODE    = "HS_RX"  ;   //HS_RX, HS_TX   lvdsi/lvdso
    parameter IDDRMODE   = "DDRX2"  ;   //OFF, DDRX1, DDRX2
    parameter GSR        = "ENABLE" ;   //ENABLE, DISABLE    
    parameter INSCLKMUX  = "0"      ;   //CLK(ioclk[1:0],gclk[3:0],jclk,0(SW default)), INV    
    parameter INPCLKMUX  = "CLK"    ;   //CLK(ioclk[0],gclk[1:0],jclk(as SW default=0)), INV   
    parameter IDDRPIPEMODE  = "NONE";   //NONE, PIPED    
    parameter INDELMUX   = "NODEL"  ;   //NODEL, FIXDEL
    parameter INDEL      = 0        ;   // 0-31
    parameter OUTSCLKMUX = "0"      ;   //CLK(ioclk[1:0],gclk[3:0],jclk,0(SW default)), INV
    parameter OUTPCLKMUX = "CLK"    ;   //CLK(ioclk[0],gclk[1:0],jclk(as SW default=0)), INV
    parameter ODDRMODE   = "OFF"    ;   //OFF, DDRX1, DDRX2, DDRX2L
    parameter OUTDELMUX  = "NODEL"  ;   //NODEL, FIXDEL
    parameter OUTDEL     = 0        ;   // 0-3
    parameter DIFFRESISTOR = "100"  ;   //NONE,100 
    
//    Default:   
        
    parameter DEDCLK     = "DISABLE";    //DISABLE, ENABLE
    parameter SRMODE     = "SYNC"   ;    //SYNC, ASYNC
    parameter TSMUX      = "TS"     ;    //1, 0, TS, INV
    parameter INCEMUX    = "1"      ;    //CE, INV, 1
    parameter INRSTMUX   = "RST"    ;    //0, RST, INV
    parameter IN_REGSET  = "RESET"  ;    //RESET, SET
    parameter IN_DFFMODE = "NONE"   ;    //NONE, FF, LATCH
    parameter OUTCEMUX   = "1"      ;    //CE, INV, 1
    parameter OUTRSTMUX  = "RST"    ;    //0, RST, INV
    parameter DO_REGSET  = "RESET"  ;    //RESET, SET
    parameter DO_DFFMODE = "NONE"   ;    //NONE, FF, LATCH
    parameter TO_REGSET  = "RESET"  ;    //RESET, SET
    parameter TO_DFFMODE = "LATCH"   ;    //NONE, FF, LATCH
    parameter DRIVE      = "NONE"   ;    //NONE, 8, 12, 16, 20 24
    parameter IOTYPE     = "LVDS25" ;    //LVCMOS25, LVCMOS12, LVCMOS18, LVCMOS33, LVDS25 ...

endmodule
