///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2011-2021 Anlogic, Inc.
// All Right Reserved.
///////////////////////////////////////////////////////////////////////////////
//
//
//   Vendor : Anlogic
//   Version : 0.1
//   Description : Anlogic Functional Simulation Library Component
//            mult
//   Filename : al_phy_mcu.v
//   Timestamp : Mon Nov  4 14:20:41 CST 2013
//
///////////////////////////////////////////////////////////////////////////////
//
// Revision:
//    02/08/17 - Initial version.
//    03/13/17 - update port names.
//    03/24/17 - update port
//    04/10/17 - update risc-v debug io
//    04/11/17 - update
//    07/11/17 - update port(add sleep_out usr_reg and delete some clocks)

///////////////////////////////////////////////////////////////////////////////
`timescale 1 ns / 1 ps

module EF3_PHY_MCU(
		ppm_clk,   
		i2s_mst_clk,   
		ppm_rstn,   
		sleep_out,   
		gpio_h_out,   
		gpio_h_oe_n,   
		gpio_h_in,   
		ahbslave_dma_req,   
		ahbslave_dma_single,   
		ahbslave_dma_ack,   
		h2h_haddr,   
		h2h_htrans,   
		h2h_hwrite,   
		h2h_hsize,   
		h2h_hburst,   
		h2h_hprot,   
		h2h_hwdata,   
		h2h_hrdata,   
		h2h_hreadyout,   
		h2h_hresp,   
		h2h_mclk,  
		h2h_rstn,  
		qspi_rxd,
		qspi_txd,
		qspi_sclk,
		qspi_ss,
		qspi_oen,
		adc1_exttrg,   
		adc2_exttrg,   
		usr_reg);
	
	
		input           ppm_clk;
		input           i2s_mst_clk;

		input           ppm_rstn;
		output          sleep_out;

		output [15:0]   gpio_h_out;
		output [15:0]   gpio_h_oe_n;
		input  [15:0]   gpio_h_in;

		input           ahbslave_dma_req;
		input           ahbslave_dma_single;
		output          ahbslave_dma_ack;
		output  [31:0]  h2h_haddr;
		output  [1:0]   h2h_htrans;
		output          h2h_hwrite;
		output  [2:0]   h2h_hsize;
		output  [2:0]   h2h_hburst;
		output  [3:0]   h2h_hprot;
		output  [31:0]  h2h_hwdata;
		input   [31:0]  h2h_hrdata;
		input           h2h_hreadyout;
		input   [1:0]   h2h_hresp;
		input           h2h_mclk;
		input           h2h_rstn;

		input   [3:0]   qspi_rxd;   //   high routing priority
		output  [3:0]   qspi_txd;   //   high routing priority
		output          qspi_sclk;   //   high routing priority
		output          qspi_ss;   //   high routing priority
		output  [3:0]   qspi_oen;   //   high routing priority

		input           adc1_exttrg;
		input           adc2_exttrg;

		output  [15:0]  usr_reg;

		parameter GPIO_L0   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L1   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L2   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L3   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L4   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L5   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L6   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L7   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L8   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L9   = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L10  = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L11  = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L12  = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L13  = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L14  = "DISABLE";  //  ENABLE/DISABLE
		parameter GPIO_L15  = "DISABLE";  //  ENABLE/DISABLEodule

endmodule
