///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2011-2021 Anlogic, Inc.
// All Right Reserved.
///////////////////////////////////////////////////////////////////////////////
//
//
//   Vendor : Anlogic
//   Version : 0.1
//   Description : Anlogic Functional Simulation Library Component
//            pwr_mnt
//   Filename : eg_pwr_mnt.v
//   Timestamp : Thu May  5 09:02:20 CST 2016
//
///////////////////////////////////////////////////////////////////////////////
//
// Revision:
//    05/05/2016 - Initial version.
///////////////////////////////////////////////////////////////////////////////

//--------------------------------------------------------------------
// Verilog HDL for "EG_PWR_MNT", "functional"
//--------------------------------------------------------------------
`timescale 1 ns / 1 ns
module EG_PHY_PWRMNT (sel_pwr, pwr_mnt_pd, pwr_dwn_n);
    output pwr_dwn_n;
    input sel_pwr;
    input pwr_mnt_pd;

  parameter MNT_LVL = 0; //1-7 1:1.86v 2:2.00v 3:2.17v 4:2.36v 5:2.60v 6:2.89v 7:3.25v

  wire pwr_dwn_n = MNT_LVL!=0;

 specify                                      
        (sel_pwr  => pwr_dwn_n) = (0:0:0, 0:0:0);
        (pwr_mnt_pd  => pwr_dwn_n) = (0:0:0, 0:0:0);

 endspecify

endmodule

