///////////////////////////////////////////////////////////////////////////////
// Copyright (c) 2011-2021 Anlogic, Inc.
// All Right Reserved.
///////////////////////////////////////////////////////////////////////////////
//
//   Vendor : Anlogic
//   Version : 0.1
//   Description : Anlogic Functional Simulation Library Component
//            OSC block
//   Filename : elf_phy_osc.v
//   Timestamp : Tue Jun 28 15:57:32 CST 2016
//
///////////////////////////////////////////////////////////////////////////////
//
// Revision:
//    06/28/16 - Initial version.
//
///////////////////////////////////////////////////////////////////////////////
`timescale 1 ns / 10 ps

module ELF_PHY_OSC (osc_dis, osc_clk);
    input osc_dis;
    output osc_clk;

    parameter FREQ = "60"; // 60, 30 MHz

    reg osc_reg, int_osc_clk;

    realtime half_period;

    initial
    begin
        int_osc_clk = 1'b0;
    end

    initial 
    begin
        case (FREQ)
            "30"  : half_period = 16.6; //16.6ns (30MHz)
            "60"  : half_period = 8.3;  //6.25ns (60MHz)
            default: half_period = 8.3; //default frequency is 60MHz
        endcase
    end

    always
        #half_period int_osc_clk = ~int_osc_clk;

    always @ (osc_dis or int_osc_clk) begin
        if (osc_dis == 1'b1)
            osc_reg = 1'b0;
        else
            osc_reg = int_osc_clk;
    end

    buf (osc_clk, osc_reg);

endmodule
